## monkey-1.6.9.tar.gz

=== CMakeLists.txt ===
# Let's have fun!

cmake_minimum_required(VERSION 2.8)
project(monkey C)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/")
set(CMAKE_INCLUDE_DIRECTORIES_BEFORE ON)

# CMake includes
include(CheckSymbolExists)
include(CheckLibraryExists)
include(CheckIncludeFile)
include(CheckCSourceCompiles)
include(ExternalProject)
include(GNUInstallDirs)

# Set default compiler options
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99 -Wall -Wextra")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D__FILENAME__='\"$(subst ${CMAKE_SOURCE_DIR}/,,$(abspath $<))\"'")

# Monkey Version
set(MK_VERSION_MAJOR  1)
set(MK_VERSION_MINOR  6)
set(MK_VERSION_PATCH  9)
set(MK_VERSION_STR "${MK_VERSION_MAJOR}.${MK_VERSION_MINOR}.${MK_VERSION_PATCH}")

# ============================================
# ============= BUILD OPTIONS ================
# ============================================

# Project
option(BUILD_LOCAL         "Build locally, no install"    No)

# Monkey Core
option(WITH_DEBUG          "Build with debug symbols"     No)
option(WITH_ACCEPT         "Use accept(2) system call"    No)
option(WITH_ACCEPT4        "Use accept4(2) system call"  Yes)
option(WITH_LINUX_KQUEUE   "Use Linux kqueue emulator"    No)
option(WITH_TRACE          "Enable Trace mode"            No)
option(WITH_UCLIB          "Enable uClib libc support"    No)
option(WITH_MUSL           "Enable Musl libc support"     No)
option(WITH_BACKTRACE      "Enable Backtrace feature"    Yes)
option(WITH_LINUX_TRACE    "Enable Lttng support"         No)
option(WITH_PTHREAD_TLS    "Use old Pthread TLS mode"     No)
option(WITH_SYSTEM_MALLOC  "Use system memory allocator"  No)
option(WITH_MBEDTLS_SHARED "Use mbedtls shared lib"       No)

# Plugins: what should be build ?, these options
# will be processed later on the plugins/CMakeLists.txt file
option(WITH_PLUGIN_AUTH          "Basic authentication"    Yes)
option(WITH_PLUGIN_CGI           "CGI support"             Yes)
option(WITH_PLUGIN_CHEETAH       "Cheetah Shell Interface" Yes)
option(WITH_PLUGIN_DIRLISTING    "Directory Listing"       Yes)
option(WITH_PLUGIN_FASTCGI       "FastCGI"                 Yes)
option(WITH_PLUGIN_LIANA         "Basic network layer"     Yes)
option(WITH_PLUGIN_LOGGER        "Log Writer"              Yes)
option(WITH_PLUGIN_MANDRIL       "Security"                Yes)
option(WITH_PLUGIN_TLS           "TLS/SSL support"          No)

# Options to build Monkey with/without binary and
# static/dynamic library modes (default is always just
# one target binary).
option(WITHOUT_BIN               "Do not build binary"      No)
option(WITHOUT_CONF              "Skip configuration files" No)
option(WITH_STATIC_LIB_MODE      "Static library mode"      No)

if(NOT CMAKE_SYSTEM_NAME STREQUAL "Linux")
  set(WITH_ACCEPT        1)
  set(WITH_ACCEPT4       0)
  set(WITH_SYSTEM_MALLOC 1)
endif()

# This variable allows to define a list of plugins that must
# be included when building the project. The value are the plugins
# names separated by a colon, e.g: -DWITH_PLUGINS=cgi,mbedtls
if(WITH_PLUGINS)
  string(REPLACE "," ";" plugins ${WITH_PLUGINS})
  foreach(name ${plugins})
    message(STATUS "Plugin force enable: ${name}")
    string(TOUPPER ${name} NAME)
    set(WITH_PLUGIN_${NAME} 1)
  endforeach()
endif()

if(WITHOUT_PLUGINS)
  string(REPLACE "," ";" plugins ${WITHOUT_PLUGINS})
  foreach(name ${plugins})
    message(STATUS "Plugin force disable: ${name}")
    string(TOUPPER ${name} NAME)
    set(WITH_PLUGIN_${NAME} 0)
  endforeach()
endif()

if(STATIC_PLUGINS)
  set(STATIC_PLUGINS "${STATIC_PLUGINS},liana")
else()
  set(STATIC_PLUGINS "liana")
endif()

# Variable to be populated by plugins/CMakeLists.txt. It will contain the
# code required to initialize any static plugin.
set(STATIC_PLUGINS_INIT "")
set(STATIC_PLUGINS_LIBS "")

# ===========================================
# ============== DEPENDENCIES ===============
# ===========================================

# Find pthreads
find_package(Threads)

if(WITH_DEBUG)
  set(CMAKE_BUILD_TYPE "Debug")
endif()

# Check for accept(2) v/s accept(4)
if(WITH_ACCEPT)
  set(WITH_ACCEPT4 No)
  add_definitions(-DACCEPT_GENERIC)
elseif(WITH_ACCEPT4)
  # accept(4) requires _GNU_SOURCE defined
  list(APPEND CMAKE_REQUIRED_DEFINITIONS -D_GNU_SOURCE)
  check_symbol_exists(accept4 sys/socket.h HAVE_ACCEPT4)
  list(REMOVE_ITEM CMAKE_REQUIRED_DEFINITIONS -D_GNU_SOURCE)

  # check the results
  if(NOT HAVE_ACCEPT4)
    # switch back to accept(2)
    set(WITH_ACCEPT Yes)
  endif()
endif()

# Check for Linux Kqueue library emulator
if(WITH_LINUX_KQUEUE)
  find_package(Libkqueue REQUIRED)
  if(NOT LIBKQUEUE_FOUND)
    message(FATAL_ERROR "Linux libkqueue was not found." )
  else()
    add_definitions(-DLINUX_KQUEUE)
  endif()
endif()

# Check Trace
if(WITH_TRACE)
  add_definitions(-DTRACE)
endif()

# Check Uclib library
if(WITH_UCLIB)
  add_definitions(-DUCLIB_MODE)
endif()

# Check Musl library
if(WITH_MUSL)
  add_definitions(-DMUSL_MODE)
endif()

# Check Backtrace support
if(WITH_BACKTRACE)
  check_include_file("execinfo.h" HAVE_BACKTRACE)
  if (NOT HAVE_BACKTRACE)
    set(WITH_BACKTRACE No)
  else()
      add_definitions(-DHAVE_BACKTRACE)
  endif()
else()
  add_definitions(-DNO_BACKTRACE)
endif()

# Check for LTTng-UST
if(WITH_LINUX_TRACE)
  check_include_file("lttng/tracepoint.h" HAVE_LTTNG)
  if (NOT HAVE_LTTNG)
    message(FATAL_ERROR "LTTng-UST is not installed in your system." )
  else()
    add_definitions(-DLINUX_TRACE)
  endif()
endif()

check_c_source_compiles("
   __thread int a;
   int main() {
       __tls_get_addr(0);
       return 0;
   }" HAVE_C_TLS)

# Use old Pthread TLS
if(WITH_PTHREAD_TLS)
  add_definitions(-DPTHREAD_TLS)
elseif(NOT HAVE_C_TLS)
  add_definitions(-DPTHREAD_TLS)
endif()

# Use system memory allocator instead of Jemalloc
if(WITH_SYSTEM_MALLOC)
  add_definitions(-DMALLOC_LIBC)
else()
  # Prepare the Jemalloc build
  add_definitions(-DMALLOC_JEMALLOC)
  add_definitions(-DJEMALLOC_MANGLE)

  # Link to Jemalloc as an external dependency
  ExternalProject_Add(jemalloc
    SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/deps/jemalloc
    CONFIGURE_COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/deps/jemalloc/configure --with-jemalloc-prefix=je_ --enable-cc-silence --prefix=<INSTALL_DIR>
    CFLAGS=-std=gnu99\ -Wall\ -pipe\ -g3\ -O3\ -funroll-loops
    BUILD_COMMAND ${MAKE}
    INSTALL_DIR ${CMAKE_CURRENT_BINARY_DIR}/
    INSTALL_COMMAND $(MAKE) install_lib_static install_include)

  add_library(libjemalloc STATIC IMPORTED GLOBAL)
  set_target_properties(libjemalloc PROPERTIES IMPORTED_LOCATION "${CMAKE_CURRENT_BINARY_DIR}/lib/libjemalloc_pic.a")
  add_dependencies(libjemalloc jemalloc)
  include_directories("${CMAKE_CURRENT_BINARY_DIR}/include/")
endif()

# ============================================
# =========== CONFIGURATION FILES=============
# ============================================

# Default values for conf/monkey.conf
set(MK_CONF_LISTEN       "2001")
set(MK_CONF_WORKERS      "0")
set(MK_CONF_TIMEOUT      "15")
set(MK_CONF_PIDFILE      "monkey.pid")
set(MK_CONF_USERDIR      "public_html")
set(MK_CONF_INDEXFILE    "index.html index.htm index.php")
set(MK_CONF_HIDEVERSION  "Off")
set(MK_CONF_RESUME       "On")
set(MK_CONF_USER         "www-data")
set(MK_CONF_KA           "On")
set(MK_CONF_KA_TIMEOUT   "5")
set(MK_CONF_KA_MAXREQ    "1000")
set(MK_CONF_REQ_SIZE     "32")
set(MK_CONF_SYMLINK      "Off")
set(MK_CONF_DEFAULT_MIME "text/plain")
set(MK_CONF_FDT          "On")
set(MK_CONF_OVERCAPACITY "Resist")

# Default values for conf/sites/default
set(MK_VH_SERVERNAME     "127.0.0.1")
set(MK_VH_DOCUMENT_ROOT  MK_DATADIR)
set(MK_VH_LOG_ACCESS     MK_LOGDIR)
set(MK_VH_LOG_ERROR      MK_LOGDIR)


# Paths
if(APPLE)
  set(CMAKE_MACOSX_RPATH ${CMAKE_MACOSX_RPATH};${CMAKE_INSTALL_FULL_LIBDIR}/monkey)
endif()

if(DEFAULT_PORT)
  set(MK_CONF_LISTEN  ${DEFAULT_PORT})
endif()

if(DEFAULT_USER)
  set(MK_CONF_USER ${DEFAULT_USER})
endif()

if(BUILD_LOCAL)
  # This mode aims to be backward compatible with older versions of Monkey where
  # a './configure && make' were enough to have the server running without installing
  # any component.
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/lib/monkey")
  set(MK_PATH_CONF     "${CMAKE_CURRENT_BINARY_DIR}/conf/")
  set(MK_PATH_PIDPATH  "${CMAKE_CURRENT_BINARY_DIR}")
  set(MK_PIDFILE       "${MK_CONF_PIDFILE}")
  set(MK_PATH_WWW      "${CMAKE_CURRENT_SOURCE_DIR}/htdocs/")
  set(MK_PATH_LOG      "${CMAKE_CURRENT_BINARY_DIR}/log/")
  file(MAKE_DIRECTORY  ${MK_PATH_LOG})
else()
  # Custom SYSCONFDIR
  if(NOT INSTALL_SYSCONFDIR)
    set(MK_PATH_CONF ${CMAKE_INSTALL_FULL_SYSCONFDIR}/monkey/ CACHE STRING "Server configuration")
  else()
    set(MK_PATH_CONF ${INSTALL_SYSCONFDIR}/ CACHE STRING "Server configuration")
  endif()

  # Custom LOGDIR
  if(NOT INSTALL_LOGDIR)
    set(MK_PATH_LOG ${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/log/monkey CACHE STRING "Server logs")
  else()
    set(MK_PATH_LOG ${INSTALL_LOGDIR} CACHE STRING "Server logs")
  endif()

  # Custom PIDPATH
  if(NOT PID_PATH)
    set(MK_PATH_PIDPATH ${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/run/ CACHE STRING "Server PID path")
  else()
    set(MK_PATH_PIDPATH ${PID_PATH} CACHE STRING "Server PID path")
  endif()

  # Custom PIDFILE
  if(NOT PID_FILE)
    set(MK_PIDFILE ${MK_CONF_PIDFILE} CACHE STRING "Server pid file name")
  else()
    set(MK_PIDFILE ${PID_FILE} CACHE STRING "Server pid file name")
endif()

  # Custom WEBROOT
  if(NOT INSTALL_WEBROOTDIR)
    set(MK_PATH_WWW ${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/www/monkey CACHE STRING "Server Web documents")
  else()
    set(MK_PATH_WWW ${INSTALL_WEBROOTDIR} CACHE STRING "Server Web documents")
  endif()

  # Headers
  if(NOT INSTALL_INCLUDEDIR)
    set(MK_PATH_HEADERS ${CMAKE_INSTALL_INCLUDEDIR}/monkey CACHE STRING "Server header files (development)")
  else()
    set(MK_PATH_HEADERS ${INSTALL_INCLUDEDIR} CACHE STRING "Server header files (development)")
  endif()
endif()

configure_file(
  "${PROJECT_SOURCE_DIR}/include/monkey/mk_info.h.in"
  "${PROJECT_SOURCE_DIR}/include/monkey/mk_info.h"
  )

configure_file(
  "${PROJECT_SOURCE_DIR}/include/monkey/mk_env.h.in"
  "${PROJECT_SOURCE_DIR}/include/monkey/mk_env.h"
  )


# General Headers
include_directories(./)
include_directories(include)
include_directories(mk_core/include)
include_directories(monkey)

# Instruct CMake to build the the code base
# =========================================
# mk_core  : generic utilities
# plugins  : plugins for mk_server
# mk_server: server code base: plugins, protocols, scheduler.. (no executable)
# mk_bin   : server executable

add_subdirectory(man)
add_subdirectory(mk_core)
add_subdirectory(plugins)
add_subdirectory(mk_server)
if(NOT WITHOUT_BIN)
  add_subdirectory(mk_bin)
endif()

# Configuration, headers generation and others
if(NOT WITHOUT_CONF)
  add_subdirectory(conf)
endif()
add_subdirectory(htdocs)
add_subdirectory(include)

# Install (missings ?) paths
install(DIRECTORY DESTINATION ${MK_PATH_WWW})

if(NOT SKIP_EMPTY_DIRS)
  install(DIRECTORY DESTINATION ${MK_PATH_PIDPATH})
  install(DIRECTORY DESTINATION ${MK_PATH_LOG})
endif()

=== Makefile ===
all:
	@$(MAKE) -C build/

install:
	@$(MAKE) -C build/ install
clean:
	@$(MAKE) -C build/ clean

=== conf/CMakeLists.txt ===
# Generate conf/monkey.conf
configure_file(
  "${PROJECT_SOURCE_DIR}/conf/monkey.conf.in"
  "${PROJECT_BINARY_DIR}/conf/monkey.conf"
  )

# Generate (copy) conf/monkey.mime
configure_file(
  "${PROJECT_SOURCE_DIR}/conf/monkey.mime.in"
  "${PROJECT_BINARY_DIR}/conf/monkey.mime"
  )

# Generate conf/sites/default
configure_file(
  "${PROJECT_SOURCE_DIR}/conf/sites/default.in"
  "${PROJECT_BINARY_DIR}/conf/sites/default"
  )

if(NOT BUILD_LOCAL)
  install(FILES
      ${PROJECT_BINARY_DIR}/conf/monkey.conf
      ${PROJECT_BINARY_DIR}/conf/monkey.mime
      ${PROJECT_BINARY_DIR}/conf/plugins.load
    DESTINATION
      ${MK_PATH_CONF})
  install(FILES
      ${PROJECT_BINARY_DIR}/conf/sites/default
    DESTINATION
      ${MK_PATH_CONF}/sites/)
endif()

=== examples/Makefile ===
CFLAGS += -Wall

CFLAGS += $(shell pkg-config --cflags monkey)
LDFLAGS += $(shell pkg-config --libs monkey)

.PHONY: all clean first

all: first hello list quiz

hello: hello.o

list: list.o

quiz: quiz.o

first:
	@echo -e "\n\tBuilding the examples." \
	"\n\n"\
	"\tThe build expects the library to be installed,\n"\
	"\tto work as closely as possible like an external app.\n\n"


clean:
	rm -f *.o hello quiz list

=== htdocs/CMakeLists.txt ===
set(htdocs
  js/cbpAnimatedHeader.js
  js/classie.js
  js/jquery.js
  js/freelancer.js
  js/bootstrap.min.js
  js/cbpAnimatedHeader.min.js
  js/jqBootstrapValidation.js
  font-awesome/css/font-awesome.min.css
  font-awesome/fonts/fontawesome-webfont.woff
  font-awesome/fonts/FontAwesome.otf
  font-awesome/fonts/fontawesome-webfont.svg
  font-awesome/fonts/fontawesome-webfont.eot
  font-awesome/fonts/fontawesome-webfont.ttf
  favicon.ico
  css/monkey.css
  css/bootstrap.min.css
  css/freelancer.css
  fonts/glyphicons-halflings-regular.woff2
  fonts/glyphicons-halflings-regular.ttf
  fonts/glyphicons-halflings-regular.svg
  fonts/glyphicons-halflings-regular.woff
  fonts/glyphicons-halflings-regular.eot
  img/mk_signature.png
  img/mk_logo.png
  img/mk_banner.png
  index.html
  )

if(NOT BUILD_LOCAL)
  foreach (file ${htdocs})
    get_filename_component(dir ${file} PATH)
    install(FILES ${file} DESTINATION ${MK_PATH_WWW}/${dir})
  endforeach()
endif()

=== include/CMakeLists.txt ===
if(NOT BUILD_LOCAL)
  install(DIRECTORY
      ${CMAKE_CURRENT_SOURCE_DIR}/monkey/
    DESTINATION
      ${MK_PATH_HEADERS})
endif()

=== man/CMakeLists.txt ===
install(FILES
  "monkey.1"
  DESTINATION "${CMAKE_INSTALL_MANDIR}/man1" COMPONENT doc)

=== mk_bin/CMakeLists.txt ===
set(src
  monkey.c
  mk_signals.c
  )

add_executable(monkey-bin ${src})
target_link_libraries(monkey-bin monkey-core-static)
set_target_properties(monkey-bin PROPERTIES OUTPUT_NAME monkey)

if(BUILD_LOCAL)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "../${CMAKE_CURRENT_BINARY_DIR}/")
else()
  install(TARGETS monkey-bin RUNTIME DESTINATION ${CMAKE_INSTALL_FULL_SBINDIR})
  configure_file (
    "${CMAKE_CURRENT_SOURCE_DIR}/systemd.in"
    "${PROJECT_SOURCE_DIR}/monkey.service"
    )
  if(SYSTEMD_DIR)
    install(FILES ${PROJECT_SOURCE_DIR}/monkey.service DESTINATION ${SYSTEMD_DIR})
  endif()
endif()

=== mk_core/CMakeLists.txt ===
SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
include (CheckCSourceCompiles)

set(src
  mk_iov.c
  mk_file.c
  mk_rconf.c
  mk_string.c
  mk_memory.c
  mk_event.c
  mk_utils.c
  mk_rbtree.c
  )

# Validate timerfd_create()
check_c_source_compiles("
  #include <sys/timerfd.h>
  int main() {
     return timerfd_create(CLOCK_REALTIME, 0);
  }" HAVE_TIMERFD_CREATE)

if (HAVE_TIMERFD_CREATE)
  add_definitions(-DHAVE_TIMERFD_CREATE)
endif()

# Validate eventfd()
check_c_source_compiles("
  #include <sys/eventfd.h>
  int main() {
     return eventfd(0, EFD_CLOEXEC);
  }" HAVE_EVENTFD)

if (HAVE_EVENTFD)
  add_definitions(-DHAVE_EVENTFD)
endif()

include_directories(include)
add_library(mk_core STATIC ${src})
target_link_libraries(mk_core ${CMAKE_THREAD_LIBS_INIT})

if(NOT WITH_SYSTEM_MALLOC)
  target_link_libraries(mk_core libjemalloc)
endif()

add_subdirectory(include)

=== mk_server/CMakeLists.txt ===
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")

set(src
  monkey.c
  mk_mimetype.c
  mk_vhost.c
  mk_header.c
  mk_config.c
  mk_user.c
  mk_utils.c
  mk_stream.c
  mk_scheduler.c
  mk_http.c
  mk_http_parser.c
  mk_socket.c
  mk_clock.c
  mk_cache.c
  mk_server.c
  mk_kernel.c
  mk_plugin.c
  )

check_symbol_exists(backtrace "execinfo.h" HAVE_BACKTRACE)
if(HAVE_BACKTRACE)
  add_definitions(-DHAVE_BACKTRACE)
endif()

# Always build a static library, thats our core :)
add_library(monkey-core-static STATIC ${src})
set_target_properties(monkey-core-static PROPERTIES OUTPUT_NAME monkey)
target_link_libraries(monkey-core-static mk_core ${CMAKE_THREAD_LIBS_INIT} ${STATIC_PLUGINS_LIBS} ${CMAKE_DL_LIBS})

# Linux Kqueue emulation
if(WITH_LINUX_KQUEUE)
  target_link_libraries(monkey-core-static kqueue)
endif()

=== plugins/CMakeLists.txt ===
set(static_plugins "" CACHE INTERNAL "static_plugins")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")

# CHECK_STATIC_PLUGIN: Check if a plugin will be linked statically
macro(CHECK_STATIC_PLUGIN name)
  string(REPLACE "," ";" plugins ${STATIC_PLUGINS})
  list(FIND plugins ${name} found)
  if(NOT found EQUAL -1)
    set(IS_STATIC TRUE)
  else()
    set(IS_STATIC FALSE)
  endif()
endmacro()

# MONKEY_PLUGIN: Used by plugins to register and create the targets
macro(MONKEY_PLUGIN name src)
  CHECK_STATIC_PLUGIN(${name})
  if(IS_STATIC)
    add_library(monkey-${name}-static STATIC ${src})
    set_target_properties(monkey-${name}-static PROPERTIES OUTPUT_NAME monkey-${name})
    set_target_properties(monkey-${name}-static PROPERTIES PREFIX "")
  else()
    if(APPLE)
      add_library(monkey-${name}-shared MODULE ${src})
    else()
      add_library(monkey-${name}-shared SHARED ${src})
    endif()
    set_target_properties(monkey-${name}-shared PROPERTIES OUTPUT_NAME monkey-${name})
    set_target_properties(monkey-${name}-shared PROPERTIES PREFIX "")

    if(NOT BUILD_LOCAL)
      if(CMAKE_INSTALL_LIBDIR)
        install(TARGETS monkey-${name}-shared LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
      else()
        install(TARGETS monkey-${name}-shared LIBRARY DESTINATION lib)
      endif()
    endif()
  endif()
endmacro()

# MK_BUILD_PLUGIN: This macro determinate if the plugin is enabled through the
# option WITH_PLUGIN_NAME defined on the root CMakeLists.txt
macro(MK_BUILD_PLUGIN name)
  set(mode "")
  string(TOUPPER ${name} NAME)

  # Check if the plugin is enabled
  set(option WITH_PLUGIN_${NAME})
  if(${option})
    add_subdirectory(${name})

    # Is this a static plugin ?
    CHECK_STATIC_PLUGIN(${name})
    if(IS_STATIC)
      # Let Monkey and CMake aware about this is a static plugin. A static plugin
      # requires a different handling: link the object and register the plugin
      # struct reference on mk_static_plugins.h
      set(static_plugins "${static_plugins}monkey-${name}-static;")
      set(STATIC_PLUGINS_INIT "${STATIC_PLUGINS_INIT}\n    p = &mk_plugin_${name};\n    mk_list_add(&p->_head, &mk_config->plugins);\n")
      set(STATIC_PLUGINS_DECL "${STATIC_PLUGINS_DECL}extern struct mk_plugin mk_plugin_${name};\n")

      # append message to stdout
      set(mode "[== static ==]")
    else()
      if(BUILD_LOCAL)
        set(MK_LOAD_PLUGINS "${MK_LOAD_PLUGINS}    # Load ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/monkey-${name}.so\n")
      else()
        set(MK_LOAD_PLUGINS "${MK_LOAD_PLUGINS}    # Load ${CMAKE_INSTALL_FULL_LIBDIR}/monkey-${name}.so\n")
      endif()
    endif()
    message(STATUS "Plugin ${name} enabled ${mode}")
  endif()
endmacro()


macro(MONKEY_PLUGIN_LINK_LIB target lib)
  CHECK_STATIC_PLUGIN(${target})
  if(IS_STATIC)
    target_link_libraries(monkey-${target}-static ${lib})
  else()
    target_link_libraries(monkey-${target}-shared ${lib})
  endif()
endmacro()

# Try to configure/build all plugins
MK_BUILD_PLUGIN("auth")
MK_BUILD_PLUGIN("cgi")
MK_BUILD_PLUGIN("cheetah")
MK_BUILD_PLUGIN("dirlisting")
MK_BUILD_PLUGIN("fastcgi")
MK_BUILD_PLUGIN("liana")
MK_BUILD_PLUGIN("logger")
MK_BUILD_PLUGIN("mandril")
MK_BUILD_PLUGIN("tls")

# Generate include/monkey/mk_static_plugins.h
configure_file(
  "${PROJECT_SOURCE_DIR}/include/monkey/mk_static_plugins.h.in"
  "${PROJECT_SOURCE_DIR}/include/monkey/mk_static_plugins.h"
  )

# Generate conf/plugins.load
if(NOT WITHOUT_CONF)
  configure_file(
    "${PROJECT_SOURCE_DIR}/conf/plugins.load.in"
    "${PROJECT_BINARY_DIR}/conf/plugins.load"
    )
endif()

set(STATIC_PLUGINS_LIBS "${static_plugins}" PARENT_SCOPE)

=== mk_core/include/CMakeLists.txt ===
# Install headers
install(FILES "mk_core.h"
        DESTINATION include/monkey/
        PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ)

file(GLOB headers "mk_core/*.h")
install(FILES ${headers}
        DESTINATION include/monkey/mk_core
        PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ)

=== debian/changelog ===
monkey (1.6.9-1) stable; urgency=low

  * Update Monkey release to v1.6.9

 -- Eduardo Silva <eduardo@monkey.io>  Sat, 04 Jun 2016 08:00:00 -0600

monkey (1.6.8-1) stable; urgency=low

  * Update Monkey release to v1.6.8

 -- Eduardo Silva <eduardo@monkey.io>  Wed, 11 Jan 2016 08:00:00 -0600

monkey (1.6.7-1) stable; urgency=low

  * Update Monkey release to v1.6.7

 -- Eduardo Silva <eduardo@monkey.io>  Wed, 30 Dec 2015 22:00:00 -0600

monkey (1.6.6-1) stable; urgency=low

  * Update Monkey release to v1.6.6

 -- Eduardo Silva <eduardo@monkey.io>  Fri, 20 Nov 2015 10:00:00 -0600

monkey (1.6.5-1) stable; urgency=low

  * Update Monkey release to v1.6.5

 -- Eduardo Silva <eduardo@monkey.io>  Thu, 10 Nov 2015 10:00:00 -0600

monkey (1.6.4-1) stable; urgency=low

  * Update Monkey release to v1.6.4

 -- Eduardo Silva <eduardo@monkey.io>  Thu, 26 Oct 2015 10:00:00 -0600

monkey (1.6.3-1) stable; urgency=low

  * Update Monkey release to v1.6.3

 -- Eduardo Silva <eduardo@monkey.io>  Fri, 09 Oct 2015 15:00:00 -0600

monkey (1.6.2-1) stable; urgency=low

  * Update Monkey release to v1.6.2

 -- Eduardo Silva <eduardo@monkey.io>  Sun, 31 Aug 2015 16:00:00 -0600

monkey (1.5.2-1) stable; urgency=low

  * Update Monkey release to v1.5.2

 -- Eduardo Silva <eduardo@monkey.io>  Fri, 18 Jul 2014 09:00:00 -0300

monkey (1.5.1-1) stable; urgency=low

  * Fix configure script parameters

 -- Eduardo Silva <edsiper@gmail.com>  Thu, 29 May 2014 09:00:00 -0300

monkey (1.5.0-1) stable; urgency=low

  * Update Monkey release to v1.5.0

 -- Eduardo Silva <edsiper@gmail.com>  Tue, 29 Apr 2014 09:00:00 -0300

monkey (1.4.0-1) stable; urgency=low

  * Update Monkey release to v1.4.0

 -- Eduardo Silva <edsiper@gmail.com>  Mon, 03 Feb 2013 09:00:00 -0300

monkey (1.3.0-1) stable; urgency=low

  * Update Monkey release to v1.3.0

 -- Eduardo Silva <edsiper@gmail.com>  Thu, 15 Oct 2013 09:00:00 -0300

monkey (1.2.0-1) stable; urgency=low

  * Update Monkey release to v1.2.0

 -- Eduardo Silva <edsiper@gmail.com>  Mon, 29 Apr 2013 10:00:00 -0300

monkey (1.1.1-1) stable; urgency=low

  * Update Monkey release to v1.1.1

 -- Eduardo Silva <edsiper@gmail.com>  Sat, 18 Aug 2012 10:00:00 -0300

monkey (1.1.0-2) stable; urgency=low

  * Add missing cgi plugin

 -- Eduardo Silva <edsiper@gmail.com>  Fri, 17 Aug 2012 12:00:00 -0300

monkey (1.1.0-1) stable; urgency=low

  * Update Monkey release to v1.1.0

 -- Eduardo Silva <edsiper@gmail.com>  Fri, 17 Aug 2012 10:00:00 -0300

monkey (0.32.0-1) unstable; urgency=low

  * Update Monkey release to v0.32.0

 -- Eduardo Silva <edsiper@gmail.com>  Fri, 09 Feb 2012 12:00:00 -0300

monkey (0.31.0-1) unstable; urgency=low

  * Update Monkey release to v0.31.0

 -- Eduardo Silva <edsiper@gmail.com>  Fri, 13 Jan 2012 12:00:00 -0300

monkey (0.21.0-1) unstable; urgency=low

  * Update Monkey release to v0.21.0

 -- Eduardo Silva <edsiper@gmail.com>  Thu, 28 Oct 2011 12:00:00 -0300

monkey (0.20.4-1) unstable; urgency=low

  * Add new monkey-dev package

 -- Eduardo Silva <edsiper@gmail.com>  Thu, 12 Oct 2011 12:00:00 -0300

monkey (0.20.3-1) unstable; urgency=low

  * Initial release

 -- Eduardo Silva <edsiper@gmail.com>  Mon, 10 Oct 2011 22:33:20 -0300

=== debian/control ===
Source: monkey
Section: httpd
Priority: optional
Maintainer: Eduardo Silva <eduardo@monkey.io>
Build-Depends: debhelper (>= 7.0.50~)
Standards-Version: 3.9.1
Homepage: http://monkey-project.com
Vcs-Git: https://github.com/monkey/monkey.git
Vcs-Browser: https://github.com/monkey/monkey

Package: monkey
Architecture: any
Depends: ${misc:Depends}
Description: Fast and lightweight Web Server for Linux.
 Monkey HTTP Server has been designed to be very scalable with low memory
 and CPU consumption, the perfect solution for embedded environments. It
 also provides a flexible API and plugins interface.

Package: monkey-dev
Architecture: any
Depends: ${misc:Depends}, monkey (= ${binary:Version})
Description: Monkey HTTP Server development files
 This package distributes the C headers files required to perform
 the development of a Monkey plugin. This package is not related to the
 library version of Monkey.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:

	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX='/usr' \
		-DCMAKE_INSTALL_SBINDIR='/usr/sbin'        \
		-DCMAKE_INSTALL_MANDIR='/usr/share/man'    \
		-DINSTALL_SYSCONFDIR='/etc/monkey'         \
		-DINSTALL_WEBROOTDIR='/usr/share/monkey'   \
		-DINSTALL_LOGDIR='/var/log/monkey'         \
		-DINSTALL_INCLUDEDIR='/usr/include/monkey' \
		-DDEFAULT_USER='www-data'                  \
	        -DDEFAULT_PORT='80'                        \
		-DCMAKE_INSTALL_LIBDIR='/usr/lib/monkey'   \
		-DPID_PATH='/var/run/'                     \
		-DWITH_PLUGIN_TLS=ON                       \
		-DSTATIC_PLUGINS='tls'                     \
		-DSYSTEMD_DIR='/lib/systemd/system/'

=== debian/watch ===
version=3
http://monkey-project.com/releases/([\d].*)/monkey-(.*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
